<?php 

 // Configuration Section

 $timeout = ini_get("max_execution_time"); // User Timeout Value
 $language = "English";		// Default Language

 $db_host	= "localhost";
 $db_user	= "username";
 $db_password	= "password";
 $db_name	= "dbname";
 $db_table	= "stutter";
 $db_type	= "mysql";


 /* TABLE Definition

  CREATE TABLE stutter (
    id INT(13)	AUTO_INCREMENT,
    date	TIMESTAMP(14),
    username	VARCHAR(100),
    room	VARCHAR(100),
    message	TEXT,
    private	VARCHAR(100),
    action	VARCHAR(10),
    PRIMARY KEY (id)
  );

 */


 $version = "1.40";

 $languages = array(
  "Chinese Big5"	=> "strings.chinese-big5.php",
  "English"		=> "strings.english.php",
  "French"		=> "strings.french.php",
  "German"		=> "strings.german.php",
  "Italian"		=> "strings.italian.php",
  "Pig Latin"		=> "strings.piglatin.php",
  "Polish"		=> "strings.polish.php",
  "Spanish"		=> "strings.spanish.php"
 );

 require_once($languages[$language]);
 require_once("DB.php");

 // create PEAR::DB DSN
 $dsn = "$db_type://$db_user:$db_password@$db_host/$db_name";

 // connect to database
 $db = DB::connect($dsn);
 $db->setFetchMode(DB_FETCHMODE_ASSOC);

 if ($StutterUser) {
  $user = $StutterUser;
 }

 function strOut($val, $message = "", $from = "") {
  global $room, $user, $str;
  $translated = $str["$val"];
  $translated = ereg_replace("\%u",$user,$translated);
  $translated = ereg_replace("\%f",$from,$translated);
  $translated = ereg_replace("\%r",$room,$translated);
  $translated = ereg_replace("\%m",$message,$translated);
  return $translated;
 }

 function stutterDisplayChat ($room, $data) {   
  global $user, $HTTP_USER_AGENT, $str;
  
  if (eregi("Macintosh",$HTTP_USER_AGENT)) { $scroll = 11; }
  else { $scroll = 200; }

  $my_lastid = $data["id"];
  if ($data["message"] && $data["username"]) {
   if ($data["private"] == "*") {
    echo strOut("toAll",$data["message"], $data["username"]);
    $nextline++;
   } 
   if (($data["private"] == "-") && ($data["username"] == $user)) {
    echo strOut("toSelf",$data["message"], $data["username"]);
    $nextline++;
   }
   if ($data["private"] == $user) {
    echo strOut("Whispered", $data["message"], $data["username"]);
    $nextline++;
   }
   if (!$data["private"]) {
    $me=$str["me"];
    if (eregi("^/$me ", $data["message"])) {
     $data["message"] = eregi_replace("^/$me ", "", $data["message"]);
     echo strOut("Emote", $data["message"], $data["username"]);
    }
    else {
     echo strOut("Public", $data["message"], $data["username"]);
    }
    $nextline++;
   }
   if ($nextline) {
    echo "\n<br>\n";
    echo "<SCRIPT LANGUAGE='JavaScript'>window.scrollBy(0, $scroll); </SCRIPT>\n";
   }
  }
  return trim($my_lastid);
 }

 function stutterSendMessage ($message, $room, $private="") {
  global $db, $user, $db_table;
  if ($user && $message) {

   $st = "INSERT INTO $db_table (username, room, message, private) VALUES ('$user', '$room', '$message', '$private')";

   if ($rc = $db->query($st)) { $rc->free(); }

   $shm_id = shmop_open(0x0fcf, "c", 0644, 100);
   $newid = trim(shmop_read($shm_id, 0, 100));
   if (!$newid) { $newid = 1; }
   $shm_bytes_written = shmop_write($shm_id, str_pad($newid + 1,100), 0);
   $newerid = trim(shmop_read($shm_id, 0, 100));
   shmop_close($shm_id);
   echo "<!-- changing shm from $newid to $newerid -->\n";
   unset($shm_id);

  }
 }

 function stutterRemoveUser ($user, $room, $reason = "") {
  global $db, $db_table;

  if (isOnline($user, $room)) {
   stutterSendMessage(addslashes(strOut("HasLeft", "", $user)), $room, "*");
   sleep(2); // (wait for everyone to get the message);
  }

  $st = "UPDATE $db_table SET username = '' WHERE room = '$room' AND username = '$user'";
  $rc = $db->query($st);

 }

 function stutterGetChat ($room) {
  global $db, $user, $timeout, $db_table;

  register_shutdown_function("stutter_shutdown");

  $st = "SELECT id FROM $db_table WHERE room = '$room' ORDER BY date DESC";
  $rc = $db->query($st);
  $data = $rc->fetchRow();
  $lastid = $data["id"];
  $rc->free();

  if (!$lastid) { $lastid = "0"; }
  else { settype($lastid, "string"); }

  echo "<!-- lastid starting at $lastid -->\n";

  $shm_id = shmop_open(0x0fcf, "c", 0644, 100);
  $shm_bytes_written = shmop_write($shm_id, str_pad($lastid, 100), 0);
  $lastid = trim(shmop_read($shm_id, 0, 100));
  shmop_close($shm_id);
  unset($shm_id);

  $lastid = $lastid - 1;

  // get rid of old entries
  $st = "DELETE FROM $db_table WHERE username = '' AND room = '$room' AND id < $lastid";
  if ($rc = $db->query($st)) { $rc->free(); }

  echo "<!-- lastid starting at $lastid -->\n";

  while (1) {
   $shm_id = shmop_open(0x0fcf, "a", 0, 0);
   $shm_data = trim(shmop_read($shm_id, 0, 100));
   shmop_close($shm_id);

   if ($shm_data > $lastid) {
    $st = "SELECT * FROM $db_table WHERE id > '$lastid' AND room = '$room'";
    echo "<!-- select $lastid -->\n";
    $rc = $db->query($st);
    for ($i=0; $i<$rc->numRows(); $i++) {
     unset($data);
     $data = $rc->fetchRow();
     $lastid = stutterDisplayChat($room, $data);
    }
    $rc->free();
   }
   flush();				// Send the output immediately.

   $idle++;
   if ($idle > ($timeout/2)) {
    echo "<!-- $shm_data $lastid -->\n";
    flush();
    $idle=0;
   }

   $sleep = 0.5;
   usleep($sleep*1000000);			// Sleep to save the CPU
   set_time_limit(3600);
  }
 }

 function isOnline($val, $room) {
  global $db, $db_table;
  $st = "SELECT id FROM $db_table WHERE username = '$val' AND room = '$room'";
  $rc = $db->query($st);
  if ($rc->numRows() > 0) { return TRUE; }
  else { return FALSE; }
  $rc->free();
 }

 function usersOnline($room) {
  global $db, $db_table, $timeout;
  $st = "SELECT DISTINCT username FROM $db_table WHERE room = '$room'";
  $rc = $db->query($st);
  for ($i=0; $i<$rc->numRows(); $i++) {
   $data = $rc->fetchRow();
   $online[]=$data["username"];
  }
  if (is_array($online)) {
   sort($online); reset($online);
  }

  $rc->free();
  return $online;
 }

 function stutter_shutdown($reason = "shutdown") {
  global $db, $user, $room;
  stutterRemoveUser($user, $room, $reason);
  $db->disconnect();
  exit;
 }

?>
